#include<bits/stdc++.h>
#include <unistd.h>

#define REP(i, n) for(int i = 0; i < n; i++)

using namespace std;

int rnd(int a, int b){
	return a + (rand() % (b-a+1));
}



// http://www.concentric.net/~Ttwang/tech/inthash.htm
// Workaround kvuli seedu na srand - proces se spousti mnohokrat za sekundu
unsigned long mix(unsigned long a, unsigned long b, unsigned long c)
{
    a=a-b;  a=a-c;  a=a^(c >> 13);
    b=b-c;  b=b-a;  b=b^(a << 8);
    c=c-a;  c=c-b;  c=c^(b >> 13);
    a=a-b;  a=a-c;  a=a^(c >> 12);
    b=b-c;  b=b-a;  b=b^(a << 16);
    c=c-a;  c=c-b;  c=c^(b >> 5);
    a=a-b;  a=a-c;  a=a^(c >> 3);
    b=b-c;  b=b-a;  b=b^(a << 10);
    c=c-a;  c=c-b;  c=c^(b >> 15);
    return c;
}



void generate_path(int n){
	cout << n << endl;
	REP(i, n-2) cout << (i+1) << " ";
	cout << (n-1) << endl;
}


void generate_star(int n){
	cout << n << endl;
	REP(i, n-2) cout << "1 ";
	cout << 1 << endl;
}

void generate_almost_star(int n){
	cout << n << endl;
	int m = 1;
	while((m+1)*(m+2) < n)++m;
	int i = 1;
	for(int j = 0;j<m;++i,++j) cout << "1 ";
	for(int j = 0; j < m;++j){
		for(int k = 0; k < m; ++i, ++k){
			cout << (j+2);
			if(i < n) cout << " ";
		}
	}
	if(i < n){
		for(;i<n-1;++i)cout << "1 ";
		cout << "1";
	}
	cout << endl;
}

void generate_tree(int n, int k){
	cout << n << endl;
	int j = 1;
	for(int i = 1;j < n;++i){
		for(int l = 0; l < k && j < n; ++l,++j){
			cout << i;
			if(j < n-1)cout << " ";
		}
	}
	cout << endl;
}


void generate_random(int n){
	cout << n << endl;
	for(int i = 1; i < n; ++i){
		cout << rnd(1, i);
		if(i < n-1) cout << " ";
	}
	cout << endl;
}


void generate_half_random_tree(int n){
	cout << n << endl;
	int i = 1;
	for(int j = 1; i < n/3;++j){
		for(int k = 0; k < 3; ++k,++i) cout << j << " ";
	}
	for(; i < n; ++i){
		cout << rnd(1, i);
		if(i < n-1) cout << " ";
	}
	cout << endl;
}

void generate_half_random_star(int n){
	cout << n << endl;
	int i = 1;
	for(; i < n/3;++i){
		cout << "1 ";
	}
	for(; i < n; ++i){
		cout << rnd(1, i);
		if(i < n-1) cout << " ";
	}
	cout << endl;
}




int main(int argc, char ** argv){
	

	vector<string> args(argv+1, argv+argc);
	int n = stoi(args[0]);

	unsigned long seed1 = stoi(args[1]);
	unsigned long seed2 = stoi(args[2]);


	unsigned long seed = mix(seed1, 4742, seed2*n);
	//cerr << seed << endl;
	srand(seed);

	char type = args[3][0];
	assert(type == 'p' || type=='s' || type=='a' || type=='t' || type=='r' || type=='x' || type=='y');


	if(type == 'p')
		generate_path(n);
	if(type == 's')
		generate_star(n);
	if(type == 'a')
		generate_almost_star(n);
	if(type == 't'){
		int k = stoi(args[4]);
		generate_tree(n, k);
	}
	if(type == 'r')
		generate_random(n);
	if(type == 'x')
		generate_half_random_tree(n);
	if(type == 'y')
		generate_half_random_star(n);

}