#include <iostream>
#include <vector>

using namespace std;

struct node {
    vector<int> sons;
};

vector<node> nodes;
vector<long long> fact;
long long MOD = 1e9 + 7;

long long calc(int x) {
    int sons = nodes[x].sons.size();
    long long res = ((x == 0 ? 1 : (sons+1)) * fact[sons]) % MOD;
    for (int i=0; i<sons; i++) {
        res *= calc(nodes[x].sons[i]);
        res %= MOD;
    }
    return res;
}

int main() {
    int n, a;
    cin >> n;

    nodes.resize(n);
    for (int i=1; i<n; i++) {
        cin >> a;
        nodes[a-1].sons.push_back(i);
    }

    fact.resize(n+1, 1);
    for (int i=1; i<=n; i++) {
        fact[i] = (i*fact[i-1]) % MOD;
    }
    cout << (n * calc(0)) % MOD << endl;
}