#include<iostream>
#include<algorithm>
#include<vector>
#include<cassert>

#define MOD 1000000007

using namespace std;

typedef long long ll;


int n;
vector<vector<int>> e;

ll fac(int n){
	ll res = 1;
	for(int i = 2; i <= n; ++i)
		res = res*i % MOD;
	return res;
}

int main(){
	cin >> n;
	e.resize(n, vector<int>{});
	vector<int> deg(n, 0);
	int a;
	for(int i = 1; i < n; ++i){
		cin >> a;
		--a;
		e[a].push_back(i);
		e[i].push_back(a);
		++deg[a];
		++deg[i];
	}

	ll res = n;
	for(int i=0; i< n; ++i)res = res*fac(deg[i]) % MOD;

	cout << res << endl;


	return 0;
}