#include<iostream>
#include<algorithm>
#include<vector>
#include<cassert>

#define MOD 1000000007

using namespace std;

typedef long long ll;


int n;
vector<vector<int>> e;
vector<ll> _dp;
vector<int> deg;


ll fac(int n){
	ll res = 1;
	for(int i = 2; i <= n; ++i)
		res = res*i % MOD;
	return res;
}



ll dp(int v, int p = -1){
	if(_dp[v] != -1)return _dp[v];
	ll ret = 1;
	for(auto u : e[v])if(u != p){
		ret = ret*dp(u, v) % MOD;
	}
	return _dp[v] = ret*fac(deg[v]) % MOD;
}


int main(){
	cin >> n;
	e.resize(n, vector<int>{});
	deg.resize(n, 0);
	_dp.resize(n, -1);
	int a;
	for(int i = 1; i < n; ++i){
		cin >> a;
		--a;
		e[a].push_back(i);
		e[i].push_back(a);
		++deg[a];
		++deg[i];
	}


	cout << (n*dp(0) % MOD) << endl;


	return 0;
}